function plotPhaseSpaceT(file)
% function plotnudpT(file)
% plot tune shift with energy from tracy output file

if nargin < 1
    file ='phase.out'
end

try
    [header data] = hdrload(file);
catch
    error('Error while opening filename %s',file)
end

%% energy in percent
dp = data(:,5)*100;
ctau = data(:,6)/(getcircumference/416)*360;

%% fractional tunes
xpos = data(:,1);
ypos = data(:,3);
xangle = data(:,2);
yangle = data(:,4);

%% Set default properties
set(0,'DefaultAxesXgrid','on');
set(0,'DefaultAxesYgrid','on');

%% Plot
figure(44)
subplot(1,2,1)
plot(xpos,xangle,'.')
xlabel('x (mm)')
ylabel('xp')

subplot(1,2,2)
plot(ypos,yangle,'.')
xlabel('y (mm)')
ylabel('yp')


addlabel(0,0,datestr(now))

h=figure(45)
subplot(3,1,1)
plot(xpos,'.')
xlabel('Turn #')
ylabel('xpos (mm)')

subplot(3,1,2)
plot(ypos,'.')
xlabel('Turn #')
ylabel('ypos (mm)')

subplot(3,1,3)
plot(dp,'.')
xlabel('Turn #')
ylabel('\delta (%)')

%suptitle('Closed orbit variation with energy')

addlabel(0,0,datestr(now))

figure(46)
plot(ctau, dp,'.', 'MarkerSize', 1)
xlabel('ctau')
ylabel('\delta (%)')
